Subject: Re: [Srcomp] New CSID Entities

From: "Darren Dukes (ddukes)" <[email-masked]>
Date: Wed, 7 Apr 2021 11:32:49 +0000

Hi Ron,

A path consisting of adjacency segments, consists only of those adjacency segments.  They are not encoded any differently than an END sid of this flavor.

Darren

On 2021-03-31, 1:45 PM, "Ron Bonica" <rbonica=[email-masked]> wrote:

Darren,

If [I-D.filsfilscheng-spring-srv6-srh-comp-sl-enc] describes new SID behaviors, the text in the analysis draft should read:

-          “CSID - [I-D.filsfilscheng-spring-srv6-srh-comp-sl-enc] - Requires three new SRv6 SID *behaviors*,  NEXT-C-SID, REPLACE-C-SID, and NEXT-AND-REPLACE- C-SID.

However, you may be creating a new SID, also. In Section 3.1 of RFC 8986, you say that a SID has a locator, function and arguments. The arguments are processed on the node that instantiates the SID. In Sections 4.1 and 4.2 of [I-D.filsfilscheng-spring-srv6-srh-comp-sl-enc], you say that a SID contains:

-          A locator block (B)

-          A NF (but you never tell us what NF stands for)

-          Arguments

The NF contains:

-          A locator node

-          A function

The argument carries the remaining C-SIDs in the current C-SID container.

If that is the case, where are the arguments that are processed on each node along the path. For example, assume that the SR-path consists of END.X segments only. Where are the arguments that identify the outbound interface. Shouldn’t they be included in NF?

                                                                                                                            Ron

Juniper Business Use Only
From: Darren Dukes (ddukes) <ddukes=[email-masked]>
Sent: Tuesday, March 30, 2021 10:24 PM
To: Ron Bonica <[email-masked]>; srcomp <[email-masked]>
Subject: Re: New CSID Entities

[External Email. Be cautious of content]

Hi Ron, please see inline [DD]

On 2021-03-29, 5:00 PM, "Srcomp" <[email-masked]<mailto:[email-masked]>> wrote:

Darren,

In the analysis document, we say:

“CSID - [I-D.filsfilscheng-spring-srv6-srh-comp-sl-enc] - Describes two new SRv6 SIDs, a combination of SIDs from [I-D.filsfils-spring-net-pgm-extension-srv6-usid] and  [I-D.cl-spring-generalized-srv6-for-cmpr]”.

In draft-filsfilscheng-spring-srv6-srh-comp-sl-enc, the authors say:

“This section defines several options to achieve compressed Segment List encoding, in the form of two new flavors for the END, END.X and  END.T behaviors of [I-D.ietf-spring-srv6-network-programming].  These    flavors could also be combined with behaviors defined in other  documents.”

What are we defining? New SIDs or new flavors for END and END.T.

[DD] The draft defines new SID behaviors, those behaviors are flavors of END, END.X, END.T.

Does CSID provide compression for paths containing only END.X segments? If so, how does the compression work?

[DD] Yes it does, section 5.2 indicates how local C-SID “may identify a cross-connect to a direct neighbor over a specific interface or a VPN context.”

Darren

                                                                                                                   Ron

Juniper Business Use Only

---

From: Ron Bonica <[email-masked]>
Date: Wed, 7 Apr 2021 16:18:28 +0000

Darren,

Let's ask the questions one at a time.

  1.  What does NF stand for?
  2.  Where does CSID encode END.X cross-connect options? For example, if a node has 255 (i.e., 2^^8) links that can used as END.X cross connects, where does CSID encode those 8 bits? In the function bits of NF?
  3.  What effect does the selected encoding have on scaling. For example, assume that we are using 16-bit encoding in a network that contains 512 (i.e., 2^^10) routers. In this case, the Locator node consumes 10 of the 16 NF bits. Only 6 bits remain for encoding END.X cross connect options. That's only 63 cross connects per node.

                                                                                 Ron

Sent: Wednesday, April 7, 2021 7:33 AM

Hi Ron,

Darren

On 2021-03-31, 1:45 PM, "Ron Bonica" <rbonica=[email-masked]<mailto:rbonica=[email-masked]>> wrote:

Darren,

"CSID - [I-D.filsfilscheng-spring-srv6-srh-comp-sl-enc] - Requires three new SRv6 SID *behaviors*,  NEXT-C-SID, REPLACE-C-SID, and NEXT-AND-REPLACE- C-SID.

A locator block (B)

A NF (but you never tell us what NF stands for)

Arguments

The NF contains:

A locator node

A function

If that is the case, where are the arguments that are processed on each node along the path. For example, assume that the SR-path consists of END.X segments only. Where are the arguments that identify the outbound interface. Shouldn't they be included in NF?

                                                                                                                            Ron

Juniper Business Use Only
From: Darren Dukes (ddukes) <ddukes=[email-masked]<mailto:ddukes=[email-masked]>>
Sent: Tuesday, March 30, 2021 10:24 PM
To: Ron Bonica <[email-masked]<mailto:[email-masked]>>; srcomp <[email-masked]<mailto:[email-masked]>>
Subject: Re: New CSID Entities

Darren,

"CSID - [I-D.filsfilscheng-spring-srv6-srh-comp-sl-enc] - Describes two new SRv6 SIDs, a combination of SIDs from [I-D.filsfils-spring-net-pgm-extension-srv6-usid] and  [I-D.cl-spring-generalized-srv6-for-cmpr]".

"This section defines several options to achieve compressed Segment List encoding, in the form of two new flavors for the END, END.X and  END.T behaviors of [I-D.ietf-spring-srv6-network-programming].  These    flavors could also be combined with behaviors defined in other  documents."

[DD] Yes it does, section 5.2 indicates how local C-SID "may identify a cross-connect to a direct neighbor over a specific interface or a VPN context."

Darren

                                                                                                                   Ron

---

From: "Darren Dukes (ddukes)" <[email-masked]>
Date: Mon, 12 Apr 2021 11:30:10 +0000

Hi Ron, see inline.

On 2021-04-07, 12:19 PM, "Ron Bonica" <rbonica=[email-masked]> wrote:

Darren,

Let’s ask the questions one at a time.

1)      What does NF stand for?
N stands for node
F stands for function

2)      Where does CSID encode END.X cross-connect options? For example, if a node has 255 (i.e., 2^^8) links that can used as END.X cross connects, where does CSID encode those 8 bits? In the function bits of NF?

The 2^16 (65k) SID space can contain global or local identifiers as described in the draft (GIB or LIB).  A node assigns its END.X cross connects from the LIB space (numbers that the operator decided have local-only significance)

3)      What effect does the selected encoding have on scaling. For example, assume that we are using 16-bit encoding in a network that contains 512 (i.e., 2^^10) routers. In this case, the Locator node consumes 10 of the 16 NF bits. Only 6 bits remain for encoding END.X cross connect options. That’s only 63 cross connects per node.

It has no effect, the operator assigns END.X SIDs from the LIB space, not the global space as you suggest.

Darren

                                                                                 Ron

Hi Ron,

Darren

Darren,

“CSID - [I-D.filsfilscheng-spring-srv6-srh-comp-sl-enc] - Requires three new SRv6 SID *behaviors*,  NEXT-C-SID, REPLACE-C-SID, and NEXT-AND-REPLACE- C-SID.

A locator block (B)

Arguments

The NF contains:

A locator node

A function

                                                                                                                            Ron

Darren,

Darren

                                                                                                                   Ron

---

From: Ron Bonica <[email-masked]>
Date: Mon, 12 Apr 2021 15:00:10 +0000

Darren,

I may be having a pre-caffeinated moment, but....

The SRv6 locator is equal to B+N. So, N must be globally allocated, regardless of whether NF represents an END SID or an END.X SID.

What am I missing?

                                                    Ron

Sent: Monday, April 12, 2021 7:30 AM

Hi Ron, see inline.

On 2021-04-07, 12:19 PM, "Ron Bonica" <rbonica=[email-masked]<mailto:rbonica=[email-masked]>> wrote:

Darren,

3)      What effect does the selected encoding have on scaling. For example, assume that we are using 16-bit encoding in a network that contains 512 (i.e., 2^^10) routers. In this case, the Locator node consumes 10 of the 16 NF bits. Only 6 bits remain for encoding END.X cross connect options. That's only 63 cross connects per node.

Darren

                                                                                 Ron

Hi Ron,

Darren

Darren,

A locator block (B)

Arguments

The NF contains:

A locator node

A function

                                                                                                                            Ron

Darren,

Darren

                                                                                                                   Ron

---

From: "Darren Dukes (ddukes)" <[email-masked]>
Date: Tue, 13 Apr 2021 11:39:27 +0000

Hi Ron, an administrator would use one or more N’s are for LIB.

Darren

On 2021-04-12, 11:01 AM, "Srcomp" <[email-masked]> wrote:

Darren,

I may be having a pre-caffeinated moment, but….

What am I missing?

                                                    Ron

Hi Ron, see inline.

Darren,

Darren

                                                                                 Ron

Hi Ron,

Darren

Darren,

A locator block (B)

Arguments

The NF contains:

A locator node

A function

                                                                                                                            Ron

Darren,

Darren

                                                                                                                   Ron

---

From: Ron Bonica <[email-masked]>
Date: Tue, 13 Apr 2021 15:03:39 +0000

Darren,

Doesn't that have an impact on scaling? Assume that:

  *   A network administrator wants to use 16-bit SIDs
  *   One of the network domains contains 512 routers
  *   So, N occupies 9 bits of NF, leaving 7 bits for F
  *   Each router instantiates 1 prefix SID and 128 adjacency SIDs

Is 16-bit CSID encoding still possible?

                                                  Ron

Juniper Business Use Only
From: Srcomp <[email-masked]> On Behalf Of Darren Dukes (ddukes)
Sent: Tuesday, April 13, 2021 7:39 AM
To: Ron Bonica <rbonica=[email-masked]>; Darren Dukes (ddukes) <ddukes=[email-masked]>; srcomp <[email-masked]>
Subject: Re: [Srcomp] New CSID Entities

Hi Ron, an administrator would use one or more N's are for LIB.

Darren

On 2021-04-12, 11:01 AM, "Srcomp" <[email-masked]<mailto:[email-masked]>> wrote:

Darren,

What am I missing?

                                                    Ron

Hi Ron, see inline.

Darren,

Darren

                                                                                 Ron

Hi Ron,

Darren

Darren,

A locator block (B)

Arguments

The NF contains:

A locator node

A function

                                                                                                                            Ron

Darren,

Darren

                                                                                                                   Ron

---

From: "Darren Dukes (ddukes)" <[email-masked]>
Date: Tue, 13 Apr 2021 17:44:20 +0000

Maybe one more coffee Ron ;)

An administrator wants a LIB of 512 things.
They uses CSIDs from 0-512 for LIB.
The GIB consists of the remaining 2^16-512 CSIDs.

Darren

On 2021-04-13, 11:04 AM, "Srcomp" <[email-masked]> wrote:

Darren,

Doesn’t that have an impact on scaling? Assume that:

-          A network administrator wants to use 16-bit SIDs

-          One of the network domains contains 512 routers

-          So, N occupies 9 bits of NF, leaving 7 bits for F

-          Each router instantiates 1 prefix SID and 128 adjacency SIDs

                                                  Ron

Darren

Darren,

What am I missing?

                                                    Ron

Hi Ron, see inline.

Darren,

Darren

                                                                                 Ron

Hi Ron,

Darren

Darren,

A locator block (B)

Arguments

The NF contains:

A locator node

A function

                                                                                                                            Ron

Darren,

Darren

                                                                                                                   Ron

---

From: Ron Bonica <[email-masked]>
Date: Tue, 13 Apr 2021 19:07:29 +0000

Darren,

In the example, each of 512 routers instantiates a prefix SID plus 128 adjacency SIDs. 512 * 129 > 2^16.

How does this work?

                                                 Ron

Juniper Business Use Only
From: Darren Dukes (ddukes) <ddukes=[email-masked]>
Sent: Tuesday, April 13, 2021 1:44 PM
To: Ron Bonica <[email-masked]>; Darren Dukes (ddukes) <[email-masked]>; srcomp <[email-masked]>
Subject: Re: New CSID Entities

Darren

On 2021-04-13, 11:04 AM, "Srcomp" <[email-masked]<mailto:[email-masked]>> wrote:

Darren,

                                                  Ron

Juniper Business Use Only
From: Srcomp <[email-masked]<mailto:[email-masked]>> On Behalf Of Darren Dukes (ddukes)
Sent: Tuesday, April 13, 2021 7:39 AM
To: Ron Bonica <rbonica=[email-masked]<mailto:rbonica=[email-masked]>>; Darren Dukes (ddukes) <ddukes=[email-masked]<mailto:ddukes=[email-masked]>>; srcomp <[email-masked]<mailto:[email-masked]>>
Subject: Re: [Srcomp] New CSID Entities

Darren

Darren,

What am I missing?

                                                    Ron

Hi Ron, see inline.

Darren,

Darren

                                                                                 Ron

Hi Ron,

Darren

Darren,

A locator block (B)

Arguments

The NF contains:

A locator node

A function

                                                                                                                            Ron

Darren,

Darren

                                                                                                                   Ron